
float[] numbers = new float[100];
int[] belongs = new int[100];

int nbGroups = 3;
float[] groupValues = new float[nbGroups];

void setup() {
  size(350, 300);
}

void draw() {
  // draw
  background(0);
  stroke(0xFF);
  for (int i=0; i<numbers.length; i++) line(50+numbers[i], 10, 50+numbers[i], 20+belongs[i]*10);
  for (int i=0; i<nbGroups; i++) line(50+groupValues[i], 50+i*20, 50+groupValues[i], 100+i*20);
}

public float vrMax(float a, float b, float m) {
  float d1=b-a;
  if (d1>m/2) {
    d1=d1-m;
  }
  if (d1<-m/2) {
    d1=d1+m;
  }
  return d1;
}

void keyPressed() {
  for (int i=0; i<numbers.length; i++) numbers[i]=i>0?(numbers[i-1]+random(abs(sin((float)i/50)*7)))%0x100:15;
  for (int i=0; i<numbers.length; i++) belongs[i]=0;
  groupValues = findGroups(numbers, 0x100);
}

float[] findGroups(float[] numbers, int max) {
  float[] groupValues = new float[nbGroups];
  for (int i=0; i<nbGroups; i++) {
    if (i==0) {
      groupValues[i]=numbers[0];
    } else {
      int bestJ=0;
      for (int j=0; j<numbers.length; j++) {
        for (int k=0; k<i; k++) {
          if (abs(vrMax(numbers[j], groupValues[k], max))>abs(vrMax(numbers[bestJ], groupValues[k], max))) {
            bestJ=j;
          }
        }
      }
      groupValues[i] = numbers[bestJ];
    }
  }
  float biggestChange=-1;
  int nbIter=0;
  while (biggestChange==-1||biggestChange>1||nbIter>100) {
    float[] groupDiffs = new float[nbGroups];
    for (int i=0; i<nbGroups; i++) {
      groupDiffs[i]=0;
      int nbNumbersInThisGroup=0;
      for (int j=0; j<numbers.length; j++) {
        int belongsToGroup=0;
        float bestDiff=vrMax(groupValues[belongsToGroup], numbers[j], max);
        for (int k=1; k<nbGroups; k++) {
          float thisDiff = vrMax(groupValues[k], numbers[j], max);
          if (abs(thisDiff)<abs(bestDiff)) {
            bestDiff=thisDiff;
            belongsToGroup=k;
          }
        }
        belongs[j]=belongsToGroup;
        if (belongsToGroup==i) {
          groupDiffs[i]+=bestDiff;
          nbNumbersInThisGroup++;
        }
      }
      groupDiffs[i]/=max(nbNumbersInThisGroup, 1);
    }
    biggestChange=-1;
    for (int i=0; i<nbGroups; i++) {
      if (biggestChange==-1||biggestChange<abs(groupDiffs[i])) biggestChange=abs(groupDiffs[i]);
    }
    for (int i=0; i<nbGroups; i++) {
      groupValues[i]=(groupValues[i]+groupDiffs[i]);
      while (groupValues[i]<0||groupValues[i]>=max) groupValues[i]=(groupValues[i]+max)%max;
    }
    nbIter++;
  }
  return groupValues;
}
